Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class VendorFunctionLibrary

    java.lang.Object
      net.sf.saxon.functions.VendorFunctionLibrary

All Implemented Interfaces:
  java.io.Serializable, FunctionLibrary

Direct Known Subclasses:
  ExtraFunctionLibrary

    public class VendorFunctionLibrary

extends java.lang.Object
implements FunctionLibrary

The VendorFunctionLibrary represents specially-recognized functions in the Saxon namespace. It doesn't handle Saxon extension functions that are implemented as normal extension functions, which are bound using the `JavaExtensionLibrary`.

See Also:
  Serialized Form

Constructor Summary
`VendorFunctionLibrary()` Create the Vendor Function Library for Saxon

Method Summary
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`protected void` | `init()`
`boolean` | `isAvailable(StructuredQName functionName, int arity)` Test whether a Saxon function with a given name and arity is available.
`Expression` | `makeSaxonFunction(java.lang.String localName, StaticContext env, Expression[] arguments)` Make a Saxon function with a given name
`static java.lang.String` | `pluralArguments(int num)` Utility routine used in constructing error messages
`protected StandardFunction.Entry` | `register(java.lang.String name, java.lang.Class implementationClass, int opcode, int minArguments, int maxArguments, ItemType itemType, int cardinality)` Register an extension function in the table of function details.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VendorFunctionLibrary

    public VendorFunctionLibrary()

  Create the Vendor Function Library for Saxon

Method Detail

### register

    protected StandardFunction.Entry register(java.lang.String name,
                                              java.lang.Class implementationClass,
                                              int opcode,
                                              int minArguments,
                                              int maxArguments,
                                              ItemType itemType,
                                              int cardinality)

  Register an extension function in the table of function details.

  Parameters:
    `name` - the function name
    `implementationClass` - the class used to implement the function
    `opcode` - identifies the function when a single class implements several functions
    `minArguments` - the minimum number of arguments required
    `maxArguments` - the maximum number of arguments allowed
    `itemType` - the item type of the result of the function
    `cardinality` - the cardinality of the result of the function
  Returns:
    the entry describing the function. The entry is incomplete, it does not yet contain information about the function arguments.

### init

    protected void init()

### isAvailable

    public boolean isAvailable(StructuredQName functionName,
                               int arity)

  Test whether a Saxon function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `isAvailable` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the name of the function
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some
  Returns:
    true if a function of this name and arity is available for calling.

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the name of the function
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `env` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function; or if this function library "owns" the namespace containing the function call, but no function was found.

### makeSaxonFunction

    public Expression makeSaxonFunction(java.lang.String localName,
                                        StaticContext env,
                                        Expression[] arguments)
                                 throws XPathException

  Make a Saxon function with a given name

  Parameters:
    `localName` - the local name of the function
    `env` - the static context
    `arguments` - the arguments of the function
  Returns:
    an exprssion representing a call on the given function
  Throws:
    `XPathException`

### pluralArguments

    public static java.lang.String pluralArguments(int num)

  Utility routine used in constructing error messages

  Parameters:
    `num` - a number
  Returns:
    the string " argument" or " arguments" if num is plural

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.